package com.ejie.ab61.model.terceros;

import java.util.Date;

import com.ejie.ab61.model.terceros.Sexo;
import com.ejie.ab61.model.terceros.TiposDocumento;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * 
 *  
 */

public class Participantes implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idParticipante;
	private Integer idEmpresa;
	private Long idTipoDocumento;
	private String numero;
	private String nombre;
	private String apellido1;
	private String apellido2;
	private Long idSexo;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Long idTipoTercero;

	private TiposDocumento tiposDocumento;
	private Sexo sexo;
	private Integer idExpediente;
	private Long telefono;
	private String email;

	public Participantes(Integer idParticipante, String numero, String nombre, String apellido1, String apellido2,
			TiposDocumento tiposDocumento, Sexo sexo, Long idTipoTercero, Integer idExpediente) {
		super();
		this.idParticipante = idParticipante;
		this.numero = numero;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.tiposDocumento = tiposDocumento;
		this.sexo = sexo;
		this.idTipoTercero = idTipoTercero;
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'Participantes'.
	 */
	public Participantes() {
	}

	/**
	 * Method 'Participantes'.
	 * 
	 * @param idParticipante
	 *            Integer
	 */
	public Participantes(Integer idParticipante) {
		this.idParticipante = idParticipante;
	}

	/**
	 * Method 'Participantes'.
	 * 
	 * @param idParticipante
	 *            Integer
	 * @param idEmpresa
	 *            Integer
	 * @param idTipoDocumento
	 *            Long
	 * @param numero
	 *            String
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 * @param idSexo
	 *            Long
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 */
	public Participantes(Integer idParticipante, Integer idEmpresa, Long idTipoDocumento, String numero, String nombre,
			String apellido1, String apellido2, Long idSexo, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltmodificacion, String usuarioUltmodificacion) {

		this.idParticipante = idParticipante;
		this.idEmpresa = idEmpresa;
		this.idTipoDocumento = idTipoDocumento;
		this.numero = numero;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.idSexo = idSexo;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'Participantes'.
	 * 
	 * @param idParticipantes
	 *            Integer
	 * @param idEmpresa
	 *            Integer
	 * @param numero
	 *            Long
	 * @param nombre
	 *            String
	 * @param apellido1
	 *            String
	 * @param apellido2
	 *            String
	 * @param sexo
	 *            String
	 * @param porcentajeParticipacion
	 *            BigDecimal
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public Participantes(Integer idParticipante, TiposDocumento tiposDocumento, String numero, String nombre,
			String apellido1, String apellido2, Sexo sexo, Date fechaRegistro, String usuarioRegistro,
			Date fechaUltModificacion, String usuarioUltModificacion) {

		this.idParticipante = idParticipante;

		this.tiposDocumento = tiposDocumento;
		this.numero = numero;
		this.nombre = nombre;
		this.apellido1 = apellido1;
		this.apellido2 = apellido2;
		this.sexo = sexo;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getIdParticipante'.
	 *
	 * @return Integer
	 */

	public Integer getIdParticipante() {
		return this.idParticipante;
	}

	/**
	 * Method 'setIdParticipante'.
	 *
	 * @param idParticipante
	 *            Integer
	 * @return
	 */

	public void setIdParticipante(Integer idParticipante) {
		this.idParticipante = idParticipante;
	}

	/**
	 * Method 'getIdEmpresa'.
	 *
	 * @return Integer
	 */

	public Integer getIdEmpresa() {
		return this.idEmpresa;
	}

	/**
	 * Method 'setIdEmpresa'.
	 *
	 * @param idEmpresa
	 *            Integer
	 * @return
	 */

	public void setIdEmpresa(Integer idEmpresa) {
		this.idEmpresa = idEmpresa;
	}

	/**
	 * Method 'getIdTipoDocumento'.
	 *
	 * @return Long
	 */

	public Long getIdTipoDocumento() {
		return this.idTipoDocumento;
	}

	/**
	 * Method 'setIdTipoDocumento'.
	 *
	 * @param idTipoDocumento
	 *            Long
	 * @return
	 */

	public void setIdTipoDocumento(Long idTipoDocumento) {
		this.idTipoDocumento = idTipoDocumento;
	}

	/**
	 * Method 'getNumero'.
	 *
	 * @return String
	 */

	public String getNumero() {
		return this.numero;
	}

	/**
	 * Method 'setNumero'.
	 *
	 * @param numero
	 *            String
	 * @return
	 */

	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * Method 'getNombre'.
	 *
	 * @return String
	 */

	public String getNombre() {
		return this.nombre;
	}

	/**
	 * Method 'setNombre'.
	 *
	 * @param nombre
	 *            String
	 * @return
	 */

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	/**
	 * Method 'getApellido1'.
	 *
	 * @return String
	 */

	public String getApellido1() {
		return this.apellido1;
	}

	/**
	 * Method 'setApellido1'.
	 *
	 * @param apellido1
	 *            String
	 * @return
	 */

	public void setApellido1(String apellido1) {
		this.apellido1 = apellido1;
	}

	/**
	 * Method 'getApellido2'.
	 *
	 * @return String
	 */

	public String getApellido2() {
		return this.apellido2;
	}

	/**
	 * Method 'setApellido2'.
	 *
	 * @param apellido2
	 *            String
	 * @return
	 */

	public void setApellido2(String apellido2) {
		this.apellido2 = apellido2;
	}

	/**
	 * Method 'getIdSexo'.
	 *
	 * @return Long
	 */

	public Long getIdSexo() {
		return this.idSexo;
	}

	/**
	 * Method 'setIdSexo'.
	 *
	 * @param idSexo
	 *            Long
	 * @return
	 */

	public void setIdSexo(Long idSexo) {
		this.idSexo = idSexo;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the tiposDocumento
	 */
	public TiposDocumento getTiposDocumento() {
		return tiposDocumento;
	}

	/**
	 * @param tiposDocumento
	 *            the tiposDocumento to set
	 */
	public void setTiposDocumento(TiposDocumento tiposDocumento) {
		this.tiposDocumento = tiposDocumento;
	}

	/**
	 * @return the sexo
	 */
	public Sexo getSexo() {
		return sexo;
	}

	/**
	 * @param sexo
	 *            the sexo to set
	 */
	public void setSexo(Sexo sexo) {
		this.sexo = sexo;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idParticipante: ").append(this.idParticipante).append(" ]");
		result.append(", [ idEmpresa: ").append(this.idEmpresa).append(" ]");
		result.append(", [ idTipoDocumento: ").append(this.idTipoDocumento).append(" ]");
		result.append(", [ numero: ").append(this.numero).append(" ]");
		result.append(", [ nombre: ").append(this.nombre).append(" ]");
		result.append(", [ apellido1: ").append(this.apellido1).append(" ]");
		result.append(", [ apellido2: ").append(this.apellido2).append(" ]");
		result.append(", [ idSexo: ").append(this.idSexo).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append("}");
		return result.toString();
	}

	public Long getIdTipoTercero() {
		return idTipoTercero;
	}

	public void setIdTipoTercero(Long idTipoTercero) {
		this.idTipoTercero = idTipoTercero;
	}

	public Integer getIdExpediente() {
		return idExpediente;
	}

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	public Long getTelefono() {
		return telefono;
	}

	public void setTelefono(Long telefono) {
		this.telefono = telefono;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

}
